## fastnetmon 1.1.3+dfsg

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)

# cmake versions:
# Debian 6 - 2.8.2
# Debian 7 - 2.8.9
# CentOS 6 - 2.8.12

# set(ENABLE_GOBGP_SUPPORT "yes")

# We should set compiler before project() call 
if (ENABLE_BUILD_IN_CPP_11_CUSTOM_ENVIRONMENT)
    # We use custom compiler too
    set(CMAKE_C_COMPILER "/opt/gcc520/bin/gcc")
    set(CMAKE_CXX_COMPILER "/opt/gcc520/bin/g++")
endif()

project(FastNetMon)

# Unfortunately, Debian Squeeze haven't support for this feature
# It added in 2.8.5 release: http://www.cmake.org/cmake/help/v2.8.5/cmake.html
# Get convinient paths for all system folders: http://www.cmake.org/gitweb?p=cmake.git;a=commitdiff;h=a262fe09
# include(GNUInstallDirs)

# Enable it and fix all warnigns!
# add_definitions ("-Wall")

set (FASTNETMON_VERSION_MAJOR 1)
set (FASTNETMON_VERSION_MINOR 1)

if (ENABLE_GOBGP_SUPPORT)
    # We could not compile gRPC without C++ 11
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -std=c++11")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -std=c++11")
endif()

# cmake -DENABLE_BUILD_IN_CPP_11_CUSTOM_ENVIRONMENT=ON .. 
if (ENABLE_BUILD_IN_CPP_11_CUSTOM_ENVIRONMENT)
    set(BOOST_INCLUDEDIR "/opt/boost_1_58_0")
    set(BOOST_LIBRARYDIR "/opt/boost_1_58_0/stage/lib/")

    # It's really nice part of this custom build process :)
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -std=c++11")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -std=c++11")

    # Disable warning from Boost when compiling with gcc 5.2
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -Wno-deprecated-declarations")

    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_RPATH};/opt/gcc520/lib64;/opt/boost_1_58_0/stage/lib")
endif()
 
# Specify full RPATH for build tree
SET(CMAKE_SKIP_BUILD_RPATH  FALSE)

# Create builds in current folder with install RPATH
SET(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)

# /opt/libgobgp_1_0_0/lib should be mentioned here explicitly!!!! We link it in runtime
SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_RPATH};/opt/libhiredis_0_13/lib;/opt/log4cpp1.1.1/lib;/opt/luajit_2.0.4/lib;/opt/ndpi/lib;/opt/pf_ring_6.0.3/lib;/opt/json-c-0.12/lib;/opt/mongo_c_driver_1_1_9/lib;/opt/libgobgp_1_0_0/lib;/opt/grpc_0_11_1_7a94236d698477636dd06282f12f706cad527029/lib;/opt/protobuf_3.0.0_alpha4/lib")

message(STATUS "C++ compilation flags: ${CMAKE_CXX_FLAGS_RELEASE}")

set(HIREDIS_CUSTOM_INSTALL_PATH "/opt/libhiredis_0_13")
set(LOG4CPP_CUSTOM_INSTALL_PATH "/opt/log4cpp1.1.1")
set(JSONC_CUSTOM_INSTALL_PATH "/opt/json-c-0.12")
set(PFRING_CUSTOM_INSTALL_PATH "/opt/pf_ring_6.0.3")
set(LIBPCAP_CUSTOM_INSTALL_PATH "/opt/libpcap_1.7.4")
set(MONGO_C_CUSTOM_INSTALL_PATH "/opt/mongo_c_driver_1_1_9")

set(FASTNETMON_PROFILER OFF)

set(FASTNETMON_PROFILE_FLAGS "-g -pg")

if (NOT CMAKE_BUILD_TYPE) 
    message(STATUS "Setting build type to Release as none was specified.")
    set(CMAKE_BUILD_TYPE Release)
endif()

if (FASTNETMON_PROFILER) 
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${FASTNETMON_PROFILE_FLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FASTNETMON_PROFILE_FLAGS}")
    set(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} ${FASTNETMON_PROFILE_FLAGS}")
endif()

### Executables definition 

# Main tool
add_executable(fastnetmon fastnetmon.cpp)

# Get last commit hash
execute_process(COMMAND git rev-list HEAD COMMAND head -n 1 OUTPUT_VARIABLE GIT_LAST_COMMIT_HASH OUTPUT_STRIP_TRAILING_WHITESPACE)

set(FASTNETMON_APPLICATION_VERSION "1.1.3 master git-${GIT_LAST_COMMIT_HASH}")
configure_file(fast_platform.h.template "${PROJECT_SOURCE_DIR}/fast_platform.h")

# With this flag we can diable PF_RING build via console: cmake .. -DDISABLE_PF_RING_SUPPORT=ON
if (NOT DISABLE_PF_RING_SUPPORT) 
    if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
        message(STATUS "You are running Linux and we can build PF_RING support")
        set (ENABLE_PFRING_SUPPORT ON)
    else()
        message(WARNING "You are running not an Linux and we can't build PF_RING support")
    endif() 
endif()

if (ENABLE_PFRING_SUPPORT)
    # Set path to manually compiled PF_RING
    set(PFRING_INCLUDE_DIRS "${PFRING_CUSTOM_INSTALL_PATH}/include")

    find_library(PFRING_LIBRARIES NAMES pfring PATHS "${PFRING_CUSTOM_INSTALL_PATH}/lib" NO_DEFAULT_PATH)

    if (NOT PFRING_LIBRARIES)
        message(FATAL_ERROR "Could not find PF_RING")
    endif()
    
    link_directories("${PFRING_CUSTOM_INSTALL_PATH}/lib")
    add_definitions(-DPF_RING)

    if (EXISTS "${PFRING_CUSTOM_INSTALL_PATH}/include/pfring_zc.h" OR EXISTS "/usr/local/include/pfring_zc.h")
        message(STATUS "We found PF_RING ZC headers and will build PF_RING ZC support")
        # Enable ZC support
        add_definitions(-DPF_RING_ZC)
    else()
        message(WARNING "We can't find PF_RING ZC header pfring_zc.h in folder /opt/pf_ring/include. Will not compile ZC support") 
    endif()

    include_directories(${PFRING_INCLUDE_DIRS})

    message(STATUS "We have enabled PF_RING's hardware filtering option")
endif()

# Our LPM library
add_library(patricia STATIC libpatricia/patricia.c)

add_library(fastnetmon_pcap_format STATIC fastnetmon_pcap_format.cpp)

# Our tools library
add_library(fast_library STATIC fast_library.cpp)

# Our ipfix database library
add_library(ipfix_rfc STATIC ipfix_rfc.cpp)

# Our packet parser
add_library(fastnetmon_packet_parser STATIC fastnetmon_packet_parser.c)

# -DENABLE_SNABBSWITCH_SUPPORT=ON ..
# Please also comment out line: set(ENABLE_LUA_SUPPORT yes) if you want SnabbSwitch support
if (ENABLE_SNABBSWITCH_SUPPORT) 
    add_definitions(-DSNABB_SWITCH)
    add_library(snabbswitch_plugin STATIC snabbswitch_plugin/snabbswitch_collector.cpp)

    link_directories(/usr/src/snabbswitch/src)
    target_link_libraries(snabbswitch_plugin snabb)
endif()

if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    execute_process(COMMAND uname -r OUTPUT_VARIABLE LINUX_KERNEL_VERSION OUTPUT_STRIP_TRAILING_WHITESPACE)
    
    # Extract major version number from Linux Kernel Version
    string(REGEX MATCH "^[0-9]+\\.[0-9]+" KERNEL_VERSION_MATCHES ${LINUX_KERNEL_VERSION})
    
    # For tests
    # set(KERNEL_VERSION_MATCHES "2.6.32")

    # We need 3.7 or more recent kernel here because older kernels are buggy
    # VERSION_GREATER comparator available from cmake 2.6.2
    if (${KERNEL_VERSION_MATCHES} VERSION_GREATER "3.7") 
        message(STATUS "You are running Linux with enough recent kernel and we can build AF_PACKET support")
        set (ENABLE_AFPACKET_SUPPORT ON)
    else()
        message(STATUS "You are running old Linux kernel and we can't build AF_PACKET support")
    endif()
endif()

# -DENABLE_AFPACKET_SUPPORT=ON ..
if (ENABLE_AFPACKET_SUPPORT)
   add_definitions(-DFASTNETMON_ENABLE_AFPACKET) 
   add_library(afpacket_plugin STATIC afpacket_plugin/afpacket_collector.cpp)
endif()

# sFLOW plugin
add_library(sflow_plugin STATIC sflow_plugin/sflow_collector.cpp) 

# netflow plugin
add_library(netflow_plugin STATIC netflow_plugin/netflow_collector.cpp)
target_link_libraries(netflow_plugin ipfix_rfc)

set(ENABLE_DPI_SUPPORT YES)
if (ENABLE_DPI_SUPPORT) 
    message(STATUS "We will enable nDPI support")

    add_library(fast_dpi STATIC fast_dpi.cpp)

    set(NDPI_INCLUDE_DIRS "/opt/ndpi/include/libndpi-1.7.1")

    find_library(NDPI_LIBRARIES NAMES ndpi PATHS "/opt/ndpi/lib" NO_DEFAULT_PATH)

    if (NOT NDPI_LIBRARIES)
        message(FATAL_ERROR "Could not find nDPI library")
    endif()

    link_directories("/opt/ndpi/lib")
    include_directories(${NDPI_INCLUDE_DIRS})

    add_definitions(-DENABLE_DPI)

    target_link_libraries(fast_dpi ${NDPI_LIBRARIES})
endif()

# We do not enable it by default, it's testing feature
# If you want it please build with:
# cmake -DENABLE_LUA_SUPPORT=ON .. 
set(ENABLE_LUA_SUPPORT yes)
if (ENABLE_LUA_SUPPORT)
    message(STATUS "We will enable LuaJIT support")

    add_definitions(-DENABLE_LUA_HOOKS)

    set(LUAJIT_CUSTOM_INSTALL_PATH "/opt/luajit_2.0.4")

    link_directories("${LUAJIT_CUSTOM_INSTALL_PATH}/lib")
    include_directories("${LUAJIT_CUSTOM_INSTALL_PATH}/include")

    find_library(LUAJIT_LIBRARY_PATH NAMES luajit-5.1 PATHS "${LUAJIT_CUSTOM_INSTALL_PATH}/lib" NO_DEFAULT_PATH)

    if (NOT LUAJIT_LIBRARY_PATH) 
        message(FATAL_ERROR "Could not find luajit library")
    endif()

    target_link_libraries(netflow_plugin ${LUAJIT_LIBRARY_PATH})
    target_link_libraries(sflow_plugin ${LUAJIT_LIBRARY_PATH})
    target_link_libraries(fast_library ${LUAJIT_LIBRARY_PATH})
endif()

# pcap plugin
add_library(pcap_plugin STATIC pcap_plugin/pcap_collector.cpp)
target_link_libraries(pcap_plugin pcap)

find_package(Threads)

if (ENABLE_PFRING_SUPPORT) 
    add_library(pfring_plugin STATIC pfring_plugin/pfring_collector.cpp)
    target_link_libraries(pfring_plugin ${PFRING_LIBRARIES})
    target_link_libraries(pfring_plugin numa)
    target_link_libraries(pfring_plugin ${CMAKE_THREAD_LIBS_INIT})

    # Add action for hardware filetring
    add_library(pfring_hardware_filter_action STATIC actions/pfring_hardware_filter_action.cpp)
endif()

if (ENABLE_GOBGP_SUPPORT)
    set(GOBGP_CUSTOM_INSTALL_PATH "/opt/libgobgp_1_0_0")
    set(GRPC_CUSTOM_INSTALL_PATH "/opt/grpc_0_11_1_7a94236d698477636dd06282f12f706cad527029")
    set(PROTOCOL_BUFFERS_CUSTOM_INSTALL_PATH "/opt/protobuf_3.0.0_alpha4")

    add_definitions(-DENABLE_GOBGP)
    add_library(gobgp_action STATIC actions/gobgp_action.cpp)

    find_path(GOBGP_INCLUDES_FOLDER NAMES libgobgp.h PATHS "${GOBGP_CUSTOM_INSTALL_PATH}/include" NO_DEFAULT_PATH)
    find_library(GOBGP_LIBRARY_PATH NAMES gobgp PATHS "${GOBGP_CUSTOM_INSTALL_PATH}/lib" NO_DEFAULT_PATH)

    if (GOBGP_INCLUDES_FOLDER AND GOBGP_LIBRARY_PATH)
        message(STATUS "We found libgobgp and will link it: ${GOBGP_INCLUDES_FOLDER} ${GOBGP_LIBRARY_PATH}")
    
        ### We do not link with it in compilation time because it broke daemonization code and pope
        ### So we use runtime dynamic linking
        ### target_link_libraries(gobgp_action ${GOBGP_LIBRARY_PATH})
        target_link_libraries(gobgp_action dl)
        include_directories(${GOBGP_INCLUDES_FOLDER})
    else()
        message(FATAL_ERROR "Could not find libgobgp")
    endif()

    find_path(GRPC_INCLUDES_FOLDER NAMES grpc/grpc.h PATHS "${GRPC_CUSTOM_INSTALL_PATH}/include" NO_DEFAULT_PATH)
    find_library(GRPC_LIBRARY_GRPC_PATH NAMES grpc PATHS "${GRPC_CUSTOM_INSTALL_PATH}/lib" NO_DEFAULT_PATH)
    find_library(GRPC_LIBRARY_GPR_PATH NAMES gpr PATHS "${GRPC_CUSTOM_INSTALL_PATH}/lib" NO_DEFAULT_PATH)
    find_library(GRPC_LIBRARY_GRPC_CPP_UNSECURE_PATH NAMES grpc++_unsecure PATHS "${GRPC_CUSTOM_INSTALL_PATH}/lib" NO_DEFAULT_PATH) 

    if (GRPC_INCLUDES_FOLDER AND GRPC_LIBRARY_GRPC_PATH AND GRPC_LIBRARY_GPR_PATH AND GRPC_LIBRARY_GRPC_CPP_UNSECURE_PATH)
        include_directories(${GRPC_INCLUDES_FOLDER})
        target_link_libraries(gobgp_action ${GRPC_LIBRARY_GRPC_PATH})
        target_link_libraries(gobgp_action ${GRPC_LIBRARY_GPR_PATH})
        target_link_libraries(gobgp_action ${GRPC_LIBRARY_GRPC_CPP_UNSECURE_PATH})
    else()
        message(FATAL_ERROR "Could not find gRPC library")
    endif()

    find_path(PROTOCOL_BUFFERS_INCLUDE_FOLDER NAMES "google/protobuf/stubs/common.h" PATHS "${PROTOCOL_BUFFERS_CUSTOM_INSTALL_PATH}/include")

    find_library(PROTOCOL_BUFFERS_LIBRARY_PATH NAMES protobuf PATHS "${PROTOCOL_BUFFERS_CUSTOM_INSTALL_PATH}/lib") 

    if (PROTOCOL_BUFFERS_INCLUDE_FOLDER AND PROTOCOL_BUFFERS_LIBRARY_PATH)
        include_directories(${PROTOCOL_BUFFERS_INCLUDE_FOLDER}) 
        target_link_libraries(gobgp_action ${PROTOCOL_BUFFERS_LIBRARY_PATH}) 
    else()
        message(FATAL_ERROR "Could not find protocol buffers")
    endif()


    # message(STATUS "grpc: ${GRPC_INCLUDES_FOLDER} ${GRPC_LIBRARY_GRPC_PATH} ${GRPC_LIBRARY_GPR_PATH}")
    # message(STATUS ${PROJECT_BINARY_DIR})

    find_program(PROTOC_BINARY protoc PATHS "${PROTOCOL_BUFFERS_CUSTOM_INSTALL_PATH}/bin" NO_DEFAULT_PATH)

    if (PROTOC_BINARY)

=== src/FreeBSD_port/Makefile ===
# $FreeBSD$

PORTNAME=	fastnetmon
PORTVERSION=	1.1.2
DISTVERSIONPREFIX=	v
CATEGORIES=	net-mgmt

MAINTAINER=	pavel.odintsov@gmail.com
COMMENT=	Very fast DDoS analyzer with sFlow/NetFLow/IPFIX/SPAN/mirror support

LICENSE=	GPLv2
LICENSE_FILE=	${WRKSRC}/LICENSE

LIB_DEPENDS=	liblog4cpp.so:${PORTSDIR}/devel/log4cpp \
		libboost_regex.so:${PORTSDIR}/devel/boost-libs

USE_GITHUB=	yes
GH_ACCOUNT=	FastVPSEestiOu

# TODO: enable this after updating /usr/ports/{UIDs,GIDs}
#USERS=		fastnetmon
#GROUPS=		fastnetmon

USES=		cmake
CMAKE_SOURCE_PATH=${WRKSRC}/src

USE_RC_SUBR=	fastnetmon

PORTDOCS=	*

OPTIONS_DEFINE=	DOCS

post-patch:
	@${REINPLACE_CMD} -e 's|/usr/local|${LOCALBASE}|' ${WRKSRC}/src/CMakeLists.txt
	@${REINPLACE_CMD} -e 's|/usr/local|${PREFIX}|; \
		s|/var/run|&/fastnetmon|g; s|/var/log|&/fastnetmon|g; \
		s|"/etc/|"${PREFIX}/etc/|g; s|/root/fastnetmon|${DATADIR}|g' \
		${WRKSRC}/src/fastnetmon.conf ${WRKSRC}/src/fastnetmon.cpp

post-install:
	${MV} ${STAGEDIR}${PREFIX}/etc/${PORTNAME}.conf \
		${STAGEDIR}${PREFIX}/etc/${PORTNAME}.conf.sample
	cd ${WRKSRC} && ${COPYTREE_SHARE} "README.md docs" ${STAGEDIR}${DOCSDIR}
	${MKDIR} ${STAGEDIR}/var/run/fastnetmon ${STAGEDIR}/var/log/fastnetmon

.include <bsd.port.mk>

=== debian/changelog ===
fastnetmon (1.1.3+dfsg-6build1) bionic; urgency=medium

  * No-change rebuild.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 10 Apr 2018 16:44:39 +0200

fastnetmon (1.1.3+dfsg-6) unstable; urgency=medium

  * Include patches to add support for Memory Model Aware Atomic Operations
    and adapt link-agains-atomic patch to __atomic_add_fetch (Closes: #869805)

 -- Benjamin Drung <benjamin.drung@profitbricks.com>  Tue, 06 Feb 2018 00:18:14 +0100

fastnetmon (1.1.3+dfsg-5) unstable; urgency=medium

  * Support nDPI 2.2 (Closes: #887623)
  * Move packaging repository to salsa.debian.org
  * Bump Standards-Version to 4.1.3 (no changes needed)
  * Switch to debhelper 11
  * Disable luajit support also on ia64, powerpc, and powerpcspe
  * Link against atomic if __sync_fetch_and_add is missing (Closes: #869805)

 -- Benjamin Drung <benjamin.drung@profitbricks.com>  Tue, 30 Jan 2018 12:29:33 +0100

fastnetmon (1.1.3+dfsg-4) unstable; urgency=medium

  * Use pkg-config for finding luajit (Closes: #873325)
  * Enable luajit support on arm64, kfreebsd-amd64, mips64el, ppc64*

 -- Benjamin Drung <benjamin.drung@profitbricks.com>  Mon, 11 Sep 2017 14:27:56 +0200

fastnetmon (1.1.3+dfsg-3) unstable; urgency=medium

  * Disable Lua support for architectures where Lua is missing
  * Disable netmap support on hurd-i386 (Closes: #869622)
  * Bump Standards-Version to 4.1.0 (no changes needed)

 -- Benjamin Drung <benjamin.drung@profitbricks.com>  Thu, 24 Aug 2017 17:02:57 +0200

fastnetmon (1.1.3+dfsg-2) unstable; urgency=medium

  * Removed code which uses x86_only features (Closes: #869621)
  * GoBGP project re-licensed gobgp_api_client.proto from Apache to MIT/Expat

 -- Benjamin Drung <benjamin.drung@profitbricks.com>  Wed, 26 Jul 2017 12:33:03 +0200

fastnetmon (1.1.3+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #862104)

 -- Benjamin Drung <benjamin.drung@profitbricks.com>  Mon, 24 Jul 2017 11:55:54 +0200

=== debian/control ===
Source: fastnetmon
Maintainer: Benjamin Drung <benjamin.drung@profitbricks.com>
Uploaders: Patrick Matthäi <pmatthaei@debian.org>
Section: net
Priority: optional
Standards-Version: 4.1.3
Build-Depends: cmake,
               debhelper (>= 11),
               libboost-atomic-dev,
               libboost-chrono-dev,
               libboost-date-time-dev,
               libboost-program-options-dev,
               libboost-regex-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libbson-dev,
               libhiredis-dev,
               libjson-c-dev,
               liblog4cpp5-dev,
               libluajit-5.1-dev [!alpha !hppa !ia64 !m68k !powerpc !powerpcspe !s390x !sh4 !sparc64 !x32],
               libmongoc-dev,
               libncurses5-dev,
               libndpi-dev,
               libpcap-dev,
               pkg-config
Homepage: https://fastnetmon.com/
Vcs-Browser: https://salsa.debian.org/debian/fastnetmon
Vcs-Git: https://salsa.debian.org/debian/fastnetmon.git

Package: fastnetmon
Architecture: any
Depends: lsb-base (>= 3.0-6), ${misc:Depends}, ${shlibs:Depends}
Description: fast DDoS analyzer with sflow/netflow/mirror support (community edition)
 FastNetMon is a very high performance distributed denial-of-service attack
 (DDoS attack) detector built on top of multiple packet capture engines:
 NetFlow, IPFIX, sFLOW.
 .
 It can detect hosts in your networks sending or receiving large volumes of
 packets/bytes/flows per second. It can call an external script to notify you,
 switch off a server, or blackhole the client.
 .
 To enable sFLOW, simply specify IP of the server running FastNetMon and specify
 (configurable) port 6343. To enable netflow, simply specify IP of the server
 running FastNetMon and specify (configurable) port 2055.
 .
 This package contains the community edition.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Disable Lua support for all architectures where libluajit-5.1-dev is not available
ifeq (,$(filter-out alpha hppa ia64 m68k powerpc powerpcspe s390x sh4 sparc64 x32,$(DEB_HOST_ARCH)))
EXTRA_ARGS = -DENABLE_LUA_SUPPORT=OFF
endif

# Disable netmap support on hurd-i386 (Closes: #869622)
ifeq (,$(filter-out hurd-i386,$(DEB_HOST_ARCH)))
EXTRA_ARGS += -DDISABLE_NETMAP_SUPPORT=ON
endif

ifeq (,$(filter-out mips mipsel m68k powerpc powerpcspe sh4,$(DEB_HOST_ARCH)))
EXTRA_ARGS += -DUSE_NEW_ATOMIC_BUILTINS=ON
endif

%:
	dh $@ --buildsystem=cmake --sourcedirectory=src

override_dh_auto_configure:
	dh_auto_configure -- -DDISABLE_PF_RING_SUPPORT=yes $(EXTRA_ARGS)

override_dh_installinit:
	dh_installinit --only-scripts

## fastnetmon 1.1.4

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -21,11 +21,17 @@
 # Get convinient paths for all system folders: http://www.cmake.org/gitweb?p=cmake.git;a=commitdiff;h=a262fe09
 # include(GNUInstallDirs)
 
+include(CheckCXXCompilerFlag)
+include(CheckLibraryExists)
+
 # Enable it and fix all warnigns!
 # add_definitions ("-Wall")
 
 set (FASTNETMON_VERSION_MAJOR 1)
 set (FASTNETMON_VERSION_MINOR 1)
+
+set(CMAKE_INSTALL_SYSTEMD_SERVICEDIR "/lib/systemd/system"
+  CACHE PATH "Location for systemd service files")
 
 if (ENABLE_GOBGP_SUPPORT)
     # We could not compile gRPC without C++ 11
@@ -81,6 +87,8 @@
     set(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} ${FASTNETMON_PROFILE_FLAGS}")
 endif()
 
+execute_process(COMMAND sh -c ". /etc/os-release; echo $ID" OUTPUT_VARIABLE OS_ID ERROR_QUIET)
+
 ### Executables definition 
 
 # Main tool
@@ -92,7 +100,30 @@
 set(FASTNETMON_APPLICATION_VERSION "1.1.3 master git-${GIT_LAST_COMMIT_HASH}")
 configure_file(fast_platform.h.template "${PROJECT_SOURCE_DIR}/fast_platform.h")
 
-# With this flag we can diable PF_RING build via console: cmake .. -DDISABLE_PF_RING_SUPPORT=ON
+# Use new Memory Model Aware Atomic Operations
+# You could enable it using: cmake .. -DUSE_NEW_ATOMIC_BUILTINS=ON
+if (USE_NEW_ATOMIC_BUILTINS)
+    message(STATUS "Will use new memory model aware atomic builtins")
+    add_definitions(-DUSE_NEW_ATOMIC_BUILTINS) 
+endif() 
+
+CHECK_CXX_SOURCE_COMPILES("
+#include <cstdint>
+int main() {
+    uint64_t x = 1;
+    __atomic_add_fetch(&x, 0, __ATOMIC_RELAXED);
+    return x;
+}
+" HAVE__ATOMIC_ADD_FETCH)
+
+if (NOT HAVE__ATOMIC_ADD_FETCH)
+    check_library_exists(atomic __atomic_add_fetch_8 "" HAVE_LIBATOMIC)
+    if (HAVE_LIBATOMIC)
+        target_link_libraries(fastnetmon atomic)
+    endif()
+endif()
+
+# With this flag we can disable PF_RING build via console: cmake .. -DDISABLE_PF_RING_SUPPORT=ON
 if (NOT DISABLE_PF_RING_SUPPORT) 
     if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
         message(STATUS "You are running Linux and we can build PF_RING support")
@@ -102,6 +133,13 @@
     endif() 
 endif()
 
+option(ENABLE_NETMAP_SUPPORT "Enable Netmap support" ON)
+
+if (ENABLE_NETMAP_SUPPORT)
+    message(STATUS "We will build Netmap support for you")
+    add_definitions(-DNETMAP_PLUGIN)
+endif()
+
 if (ENABLE_PFRING_SUPPORT)
     # Set path to manually compiled PF_RING
     set(PFRING_INCLUDE_DIRS "${PFRING_CUSTOM_INSTALL_PATH}/include")
@@ -135,6 +173,10 @@
 
 # Our tools library
 add_library(fast_library STATIC fast_library.cpp)
+
+# Our parser
+add_library(unified_parser STATIC unified_parser.cpp)
+target_link_libraries(unified_parser fastnetmon_packet_parser)
 
 # Our ipfix database library
 add_library(ipfix_rfc STATIC ipfix_rfc.cpp)
@@ -175,6 +217,7 @@
 if (ENABLE_AFPACKET_SUPPORT)
    add_definitions(-DFASTNETMON_ENABLE_AFPACKET) 
    add_library(afpacket_plugin STATIC afpacket_plugin/afpacket_collector.cpp)
+   target_link_libraries(afpacket_plugin unified_parser)
 endif()
 
 # sFLOW plugin
@@ -184,7 +227,7 @@
 add_library(netflow_plugin STATIC netflow_plugin/netflow_collector.cpp)
 target_link_libraries(netflow_plugin ipfix_rfc)
 
-set(ENABLE_DPI_SUPPORT YES)
+option(ENABLE_DPI_SUPPORT "Enable Deep Packet Inspection support" ON)
 if (ENABLE_DPI_SUPPORT) 
     message(STATUS "We will enable nDPI support")
 
@@ -209,7 +252,7 @@
 # We do not enable it by default, it's testing feature
 # If you want it please build with:
 # cmake -DENABLE_LUA_SUPPORT=ON .. 
-set(ENABLE_LUA_SUPPORT yes)
+option(ENABLE_LUA_SUPPORT "Enable Lua support" ON)
 if (ENABLE_LUA_SUPPORT)
     message(STATUS "We will enable LuaJIT support")
 
@@ -275,30 +318,3 @@
     find_library(GRPC_LIBRARY_GPR_PATH NAMES gpr PATHS "${GRPC_CUSTOM_INSTALL_PATH}/lib" NO_DEFAULT_PATH)
     find_library(GRPC_LIBRARY_GRPC_CPP_UNSECURE_PATH NAMES grpc++_unsecure PATHS "${GRPC_CUSTOM_INSTALL_PATH}/lib" NO_DEFAULT_PATH) 
 
-    if (GRPC_INCLUDES_FOLDER AND GRPC_LIBRARY_GRPC_PATH AND GRPC_LIBRARY_GPR_PATH AND GRPC_LIBRARY_GRPC_CPP_UNSECURE_PATH)
-        include_directories(${GRPC_INCLUDES_FOLDER})
-        target_link_libraries(gobgp_action ${GRPC_LIBRARY_GRPC_PATH})
-        target_link_libraries(gobgp_action ${GRPC_LIBRARY_GPR_PATH})
-        target_link_libraries(gobgp_action ${GRPC_LIBRARY_GRPC_CPP_UNSECURE_PATH})
-    else()
-        message(FATAL_ERROR "Could not find gRPC library")
-    endif()
-
-    find_path(PROTOCOL_BUFFERS_INCLUDE_FOLDER NAMES "google/protobuf/stubs/common.h" PATHS "${PROTOCOL_BUFFERS_CUSTOM_INSTALL_PATH}/include")
-
-    find_library(PROTOCOL_BUFFERS_LIBRARY_PATH NAMES protobuf PATHS "${PROTOCOL_BUFFERS_CUSTOM_INSTALL_PATH}/lib") 
-
-    if (PROTOCOL_BUFFERS_INCLUDE_FOLDER AND PROTOCOL_BUFFERS_LIBRARY_PATH)
-        include_directories(${PROTOCOL_BUFFERS_INCLUDE_FOLDER}) 
-        target_link_libraries(gobgp_action ${PROTOCOL_BUFFERS_LIBRARY_PATH}) 
-    else()
-        message(FATAL_ERROR "Could not find protocol buffers")
-    endif()
-
-
-    # message(STATUS "grpc: ${GRPC_INCLUDES_FOLDER} ${GRPC_LIBRARY_GRPC_PATH} ${GRPC_LIBRARY_GPR_PATH}")
-    # message(STATUS ${PROJECT_BINARY_DIR})
-
-    find_program(PROTOC_BINARY protoc PATHS "${PROTOCOL_BUFFERS_CUSTOM_INSTALL_PATH}/bin" NO_DEFAULT_PATH)
-
-    if (PROTOC_BINARY)

=== debian/changelog ===
fastnetmon (1.1.4-1build5) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Mar 2020 08:51:22 +0100

fastnetmon (1.1.4-1build4) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:20:44 +0100

fastnetmon (1.1.4-1build3) focal; urgency=medium

  * No-change rebuild against libndpi2.6, because ndpi 3.0-1 is broken

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 23 Feb 2020 12:46:19 -0800

fastnetmon (1.1.4-1build2) focal; urgency=medium

  * No-change rebuild against libboost-regex1.67.0-icu65

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 13 Feb 2020 18:55:26 +0000

fastnetmon (1.1.4-1build1) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 20:21:50 +0000

fastnetmon (1.1.4-1) unstable; urgency=medium

  * New upstream release.
  * Drop 18 patches that are included upstream and refresh remaining patches

 -- Benjamin Drung <benjamin.drung@cloud.ionos.com>  Mon, 08 Jul 2019 16:16:29 +0200

fastnetmon (1.1.3+dfsg-8) unstable; urgency=medium

  * Add patch for changed include path in nDPI 2.6 (Closes: #919861)
  * Disable Lua support on riscv64 (libluajit-5.1-dev needed there)
  * Bump Standards-Version to 4.3.0 (no changes needed)

 -- Benjamin Drung <benjamin.drung@cloud.ionos.com>  Mon, 21 Jan 2019 14:38:46 +0100

fastnetmon (1.1.3+dfsg-7) unstable; urgency=medium

  [ Jesse Norell ]
  * Fixed insecure permissions for fastnetmon.dat

  [ Benjamin Drung ]
  * Update my email address to @cloud.ionos.com
  * Bump Standards-Version to 4.2.1 (no changes needed)

 -- Benjamin Drung <benjamin.drung@cloud.ionos.com>  Fri, 21 Dec 2018 11:44:23 +0100

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: fastnetmon
-Maintainer: Benjamin Drung <benjamin.drung@profitbricks.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Benjamin Drung <benjamin.drung@cloud.ionos.com>
 Uploaders: Patrick Matthäi <pmatthaei@debian.org>
 Section: net
 Priority: optional
-Standards-Version: 4.1.3
+Standards-Version: 4.3.0
 Build-Depends: cmake,
                debhelper (>= 11),
                libboost-atomic-dev,
@@ -17,7 +18,7 @@
                libhiredis-dev,
                libjson-c-dev,
                liblog4cpp5-dev,
-               libluajit-5.1-dev [!alpha !hppa !ia64 !m68k !powerpc !powerpcspe !s390x !sh4 !sparc64 !x32],
+               libluajit-5.1-dev [!alpha !hppa !ia64 !m68k !powerpc !powerpcspe !riscv64 !s390x !sh4 !sparc64 !x32],
                libmongoc-dev,
                libncurses5-dev,
                libndpi-dev,

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 # Disable Lua support for all architectures where libluajit-5.1-dev is not available
-ifeq (,$(filter-out alpha hppa ia64 m68k powerpc powerpcspe s390x sh4 sparc64 x32,$(DEB_HOST_ARCH)))
+ifeq (,$(filter-out alpha hppa ia64 m68k powerpc powerpcspe riscv64 s390x sh4 sparc64 x32,$(DEB_HOST_ARCH)))
 EXTRA_ARGS = -DENABLE_LUA_SUPPORT=OFF
 endif

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg// \
https://github.com/pavel-odintsov/fastnetmon/releases .*/v(\d\S+)\.tar\.gz

## fastnetmon 1.2.2

=== src/CMakeLists.txt ===
# It's version of cmake in our oldest supported distro CentOS 7: https://repology.org/project/cmake/versions
cmake_minimum_required (VERSION 2.8.12)

set(FASTNETMON_LIBRARIES_GLOBAL_PATH "/opt/fastnetmon-community/libraries")

project(FastNetMon)

include(GNUInstallDirs)

include(CheckCXXCompilerFlag)
include(CheckLibraryExists)

# Enable it and fix all warnings
# add_definitions ("-Wall")

set (FASTNETMON_VERSION_MAJOR 1)
set (FASTNETMON_VERSION_MINOR 2)
set (FASTNETMON_VERSION_PATCH 2)

set(HIREDIS_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/libhiredis_0_13")
set(LOG4CPP_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/log4cpp1.1.3")
set(JSONC_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/json-c-0.13")
set(LIBPCAP_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/libpcap_1.7.4")
set(MONGO_C_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/mongo_c_driver_1_16_1")
set(CAPNP_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/capnproto_0_8_0")
set(OPENSSL_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/openssl_1_0_2d")
set(GRPC_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/grpc_1_30_2")

set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} --std=c++2a")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} --std=c++2a")

# With this flag we can enable GoBGP build via console: cmake .. -DENABLE_GOBGP_SUPPORT=ON
option(ENABLE_GOBGP_SUPPORT "Enable GoBGP support build" ON)

# On some platforms like Fedora we need to explicitly link with libabseil / libabsl.
# We do not use it directly but gRPC uses it for libgpr and we need to link with absl explicitly to avoid linker errors like this:
# libgpr.so: undefined reference to symbol '_ZN4absl12lts_202103245Mutex4LockEv'
# /usr/lib64/libabsl_synchronization.so.2103.0.1: error adding symbols: DSO missing from command line
option(LINK_WITH_ABSL "Enable optonal linking with ABSL" OFF)

option(DO_NOT_USE_SYSTEM_LIBRARIES_FOR_BUILD "Disables use of libraries from system path" ON)

if (DO_NOT_USE_SYSTEM_LIBRARIES_FOR_BUILD)
    # We need to avoid using system path for libraries and includes search because we ship specific versions of our own libraries in package
    # And we need to avoid implit fallbacks to system libraries as it will break dependencies
    set(DISABLE_DEFAULT_PATH_SEARCH_VAR "NO_DEFAULT_PATH")
else ()
    # Disable this logic and allow any paths
    set(DISABLE_DEFAULT_PATH_SEARCH_VAR "")
endif()

option(ENABLE_CUSTOM_BOOST_BUILD "Enable build with custom Boost" ON)
if (ENABLE_CUSTOM_BOOST_BUILD)
    message(STATUS "Build with custom Boost")

    set(Boost_NO_SYSTEM_PATHS ON)

    set(BOOST_INCLUDEDIR "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/boost_1_78_0")
    set(BOOST_LIBRARYDIR "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/boost_1_78_0/stage/lib/")

    SET(Boost_DIR "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/boost_1_78_0/stage/lib/cmake/Boost-1.78.0/")

    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -Wno-deprecated-declarations")

    set(ICU_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/libicu_65_1")

    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_RPATH};${FASTNETMON_LIBRARIES_GLOBAL_PATH}/boost_1_78_0/stage/lib;${ICU_CUSTOM_INSTALL_PATH}/lib;${FASTNETMON_LIBRARIES_GLOBAL_PATH}/gcc1210/lib64")

    # For custom Boost we need to build libicu library
    find_library(ICU_LIBRARY_UC_PATH NAMES icuuc PATHS "${ICU_CUSTOM_INSTALL_PATH}/lib" ${DISABLE_DEFAULT_PATH_SEARCH_VAR})
    find_library(ICU_LIBRARY_DATA_PATH NAMES icudata PATHS "${ICU_CUSTOM_INSTALL_PATH}/lib" ${DISABLE_DEFAULT_PATH_SEARCH_VAR})
    find_library(ICU_LIBRARY_I18N_PATH NAMES icui18n PATHS "${ICU_CUSTOM_INSTALL_PATH}/lib" ${DISABLE_DEFAULT_PATH_SEARCH_VAR})

    if (ICU_LIBRARY_UC_PATH AND ICU_LIBRARY_DATA_PATH AND ICU_LIBRARY_I18N_PATH)
        message(STATUS "Found libicu")
    else()
        message(FATAL_ERROR "Could not find icu libraries ${ICU_LIBRARY_UC_PATH} ${ICU_LIBRARY_DATA_PATH} ${ICU_LIBRARY_I18N_PATH}")
    endif()

endif()

# We use hardcoded RPATH for our libraries only when we compile against our custom libraries
if (DO_NOT_USE_SYSTEM_LIBRARIES_FOR_BUILD) 

    # Specify full RPATH for build tree
    SET(CMAKE_SKIP_BUILD_RPATH  FALSE)

    # Create builds in current folder with install RPATH
    SET(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)

    SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_RPATH};${FASTNETMON_LIBRARIES_GLOBAL_PATH}/libhiredis_0_13/lib;${FASTNETMON_LIBRARIES_GLOBAL_PATH}/log4cpp1.1.3/lib;${FASTNETMON_LIBRARIES_GLOBAL_PATH}/json-c-0.13/lib;${MONGO_C_CUSTOM_INSTALL_PATH}/lib;${MONGO_C_CUSTOM_INSTALL_PATH}/lib64;${GRPC_CUSTOM_INSTALL_PATH}/lib;${FASTNETMON_LIBRARIES_GLOBAL_PATH}/protobuf_3.11.4/lib;${CAPNP_CUSTOM_INSTALL_PATH}/lib;${OPENSSL_CUSTOM_INSTALL_PATH}/lib")

else()
   # We do not need any RPATH alterations when we want to link with system libraries (i.e. upstream builds for Debian or RedHat family)
endif()

message(STATUS "C++ compilation flags: ${CMAKE_CXX_FLAGS_RELEASE}")
message(STATUS "C++ debug compilation flags: ${CMAKE_CXX_FLAGS_DEBUG}")

set(FASTNETMON_PROFILER OFF)

set(FASTNETMON_PROFILE_FLAGS "-g -pg")

# set(CMAKE_BUILD_TYPE DEBUG)

if (NOT CMAKE_BUILD_TYPE) 
    message(STATUS "Setting build type to Release as none was specified.")
    set(CMAKE_BUILD_TYPE Release)
endif()

if (FASTNETMON_PROFILER) 
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${FASTNETMON_PROFILE_FLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FASTNETMON_PROFILE_FLAGS}")
    set(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} ${FASTNETMON_PROFILE_FLAGS}")
endif()

execute_process(COMMAND sh -c ". /etc/os-release; echo $ID" OUTPUT_VARIABLE OS_ID ERROR_QUIET)

### Executables definition 

# Main tool
add_executable(fastnetmon fastnetmon.cpp)

# Get last commit hash
execute_process(COMMAND git rev-list HEAD COMMAND head -n 1 OUTPUT_VARIABLE GIT_LAST_COMMIT_HASH OUTPUT_STRIP_TRAILING_WHITESPACE)

set(FASTNETMON_APPLICATION_VERSION "${FASTNETMON_VERSION_MAJOR}.${FASTNETMON_VERSION_MINOR}.${FASTNETMON_VERSION_PATCH} master git-${GIT_LAST_COMMIT_HASH}")
configure_file(fast_platform.h.template "${PROJECT_SOURCE_DIR}/fast_platform.h")

# Use new Memory Model Aware Atomic Operations
# You could enable it using: cmake .. -DUSE_NEW_ATOMIC_BUILTINS=ON
# We use it for exotic platforms where we have no specific functions in atomics library: https://salsa.debian.org/debian/fastnetmon/-/blob/master/debian/rules#L11
if (USE_NEW_ATOMIC_BUILTINS)
    message(STATUS "Will use new memory model aware atomic builtins")
    add_definitions(-DUSE_NEW_ATOMIC_BUILTINS) 
endif() 

# Be default we do not link with it but we need it on platforms without native support for atomic operations
# On these platforms we will use logic emulated by libatomic
set(LINK_WITH_ATOMIC_LIBRARY OFF)

CHECK_CXX_SOURCE_COMPILES("
#include <cstdint>
int main() {
    uint64_t x = 1;
    __atomic_add_fetch(&x, 0, __ATOMIC_RELAXED);
    return x;
}
" HAVE__ATOMIC_ADD_FETCH)

if (HAVE__ATOMIC_ADD_FETCH)
    message(STATUS "We have __atomic_add_fetch on this platform")
else()
    message(STATUS "We have no __atomic_add_fetch, will try linking with libatomic")

    check_library_exists(atomic __atomic_add_fetch_8 "" HAVE_LIBATOMIC)

    if (HAVE_LIBATOMIC)
        message(STATUS "Linked with atomic library")
        set(LINK_WITH_ATOMIC_LIBRARY ON)
    else()
        message(STATUS "We have no support for __atomic_add_fetch in atomic library, skip linking")
    endif()
endif()

CHECK_CXX_SOURCE_COMPILES("
#include <cstdint>
int main() {
    uint64_t x = 1;
    __sync_fetch_and_add(&x, 1);
    return x;
}
" HAVE__SYNC_FETCH_AND_ADD)

if (HAVE__SYNC_FETCH_AND_ADD) 
    message(STATUS "We have __sync_fetch_and_add on this platform")
else()
    # We know that it happens for mipsel platform due to https://reviews.llvm.org/D45691
    message(STATUS "We have no __sync_fetch_and_add on this platform, will try linking with libatomic")
    
    check_library_exists(atomic __sync_fetch_and_add_8 "" HAVE_LIBATOMIC_SYNC_FETCH_AND_ADD)

    if (HAVE_LIBATOMIC_SYNC_FETCH_AND_ADD)
        message(STATUS "Linked with atomic library")
        set(LINK_WITH_ATOMIC_LIBRARY ON)
    else()
        message(STATUS "We have no support for __sync_fetch_and_add in atomic library, skip linking")
    endif()
endif()

option(ENABLE_NETMAP_SUPPORT "Enable Netmap support" OFF)

CHECK_CXX_SOURCE_COMPILES("
int main() {
    __atomic_thread_fence(__ATOMIC_RELEASE);
    __atomic_thread_fence(__ATOMIC_ACQUIRE);
    return 0;
}
" HAVE_ATOMIC_THREAD_FENCE)

# If we do not have it then we need to disable it
if (NOT HAVE_ATOMIC_THREAD_FENCE) 
    set(ENABLE_NETMAP_SUPPORT OFF)
    message(STATUS "Your system does not support __atomic_thread_fence, disabled Netmap plugin support")
endif()

if (ENABLE_NETMAP_SUPPORT)
    message(STATUS "We will build Netmap support for you")
    add_definitions(-DNETMAP_PLUGIN)
endif()

# It's enabled by default but can be disabled using: 
# cmake .. -DENABLE_CAPNP_SUPPORT=OFF
option(ENABLE_CAPNP_SUPPORT "Enable Cap'N'Proto support build" ON)

if (ENABLE_CAPNP_SUPPORT)

message(STATUS "We will build Cap'N'Proto support")

find_program(CAPNP_BINARY capnp PATHS "${CAPNP_CUSTOM_INSTALL_PATH}/bin" ${DISABLE_DEFAULT_PATH_SEARCH_VAR})

if (CAPNP_BINARY)
    message(STATUS "Found capnp compiler: ${CAPNP_BINARY}")
else()
    message(FATAL_ERROR "Can't find capnp compiler")
endif()


# Generate capnp bindings
ADD_CUSTOM_COMMAND(
    OUTPUT ${PROJECT_SOURCE_DIR}/simple_packet_capnp/simple_packet.capnp.c++
    DEPENDS ${PROJECT_SOURCE_DIR}/simple_packet_capnp/simple_packet.capnp
    COMMAND "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}" "PATH=$ENV{PATH}:${CAPNP_CUSTOM_INSTALL_PATH}/bin" ${CAPNP_BINARY} compile --output c++:${PROJECT_SOURCE_DIR}/simple_packet_capnp --src-prefix=${PROJECT_SOURCE_DIR}/simple_packet_capnp ${PROJECT_SOURCE_DIR}/simple_packet_capnp/simple_packet.capnp
    COMMENT "Build Cap'n'Proto binding for C++"
)

add_library(simple_packet_capnp STATIC simple_packet_capnp/simple_packet.capnp.c++)

endif()

# Our LPM library
add_library(patricia STATIC libpatricia/patricia.cpp)

# Graphite metrics
add_library(graphite_metrics STATIC metrics/graphite.cpp)
target_link_libraries(fastnetmon graphite_metrics)

# InfluxDB metrics
add_library(influxdb_metrics STATIC metrics/influxdb.cpp)
target_link_libraries(fastnetmon influxdb_metrics)

add_library(fastnetmon_pcap_format STATIC fastnetmon_pcap_format.cpp)

# Our tools library
add_library(fast_library STATIC fast_library.cpp)

# Our parser
add_library(unified_parser STATIC unified_parser.cpp)
target_link_libraries(unified_parser fastnetmon_packet_parser)

# Our ipfix database library
add_library(ipfix_rfc STATIC ipfix_rfc.cpp)

add_library(bgp_protocol STATIC bgp_protocol.cpp)

# Our packet parser
add_library(fastnetmon_packet_parser STATIC fastnetmon_packet_parser.c)

# Our logic library
add_library(fastnetmon_logic STATIC fastnetmon_logic.cpp)

CHECK_CXX_SOURCE_COMPILES("
#include <linux/if_packet.h>
int main() {
    return TPACKET_V3;
}
" HAVE_TPACKET_V3)


if (${HAVE_TPACKET_V3})
    message(STATUS "Your system has support for AF_PACKET v3")
    set (ENABLE_AFPACKET_SUPPORT ON)
else()
    message(STATUS "Your system does not support AF_PACKET v3, disabled it")
endif()

# -DENABLE_AFPACKET_SUPPORT=ON ..
if (ENABLE_AFPACKET_SUPPORT)
   add_definitions(-DFASTNETMON_ENABLE_AFPACKET) 
   add_library(afpacket_plugin STATIC afpacket_plugin/afpacket_collector.cpp)
   target_link_libraries(afpacket_plugin unified_parser)
endif()

# Library with data types for parsing network structures
add_library(network_data_structures STATIC network_data_structures.cpp)

# Our new parser for parsing traffic up to L4
add_library(simple_packet_parser_ng STATIC simple_packet_parser_ng.cpp)
target_link_libraries(simple_packet_parser_ng network_data_structures)

# Our own sFlow parser library
set_source_files_properties(libsflow/libsflow.cpp PROPERTIES COMPILE_FLAGS -pedantic)

=== debian/changelog ===
fastnetmon (1.2.2-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 28 Jun 2022 11:44:16 +0200

fastnetmon (1.2.2-1) unstable; urgency=medium

  * New upstream release.
    - Lua support was removed.
  * Adjust lintian override.
  * Do not install old init.d scripts anymore.

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 22 Jun 2022 15:51:23 +0200

fastnetmon (1.2.1-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.6.1.

 -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 16 May 2022 14:08:09 +0200

fastnetmon (1.2.0+git20220506-1) unstable; urgency=medium

  * New upstream git snapshot.
    - Another try to fix mipsel build.

 -- Patrick Matthäi <pmatthaei@debian.org>  Fri, 06 May 2022 08:51:00 +0200

fastnetmon (1.2.0+git20220505-1) unstable; urgency=medium

  * New upstream git snapshot.
    - Another try to fix mipsel build.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 05 May 2022 09:37:44 +0200

fastnetmon (1.2.0+git20220504-1) unstable; urgency=medium

  * New upstream git snapshot.
    - Adjust debian/copyright.
    - This release should fix a FTBFS on mipsel.

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 04 May 2022 16:05:49 +0200

fastnetmon (1.2.0+git20220503-1) unstable; urgency=medium

  * New upstream release.
    - Add new build dependency libicu-dev, capnproto, protobuf-compiler-grpc
      and golang-github-osrg-gobgp-dev.
    - Netmap and ndpi support has been removed.
      Closes: #981774
    - Removed all previous patches. The build system has been reworked by
      upstream, thanks for it!
    - Use new DO_NOT_USE_SYSTEM_LIBRARIES_FOR_BUILD build switch.
  * Bump Standards-Version to 4.6.0.
  * Set Rules-Requires-Root to no.
  * Remove old dependency on lsb-base.
  * Upgrade packaging to debhelper compat level 13.
  * Set myself as maintainer and remove Benjaming Drung. Thanks for your great
    work!
  * Set debian/watch version to 4.
  * Update debian/copyright.
  * Adjust some lintian overrides.
  * Add missing misc:Pre-Depends dependency.

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 03 May 2022 09:34:44 +0200

=== debian/control ===
Source: fastnetmon
Maintainer: Patrick Matthäi <pmatthaei@debian.org>
Section: net
Priority: optional
Standards-Version: 4.6.1
Rules-Requires-Root: no
Build-Depends: cmake,
 debhelper-compat (= 13),
 libboost-atomic-dev,
 libboost-chrono-dev,
 libboost-date-time-dev,
 libboost-program-options-dev,
 libboost-regex-dev,
 libboost-system-dev,
 libboost-thread-dev,
 libbson-dev,
 libcapnp-dev,
 libgrpc-dev,
 libgrpc++-dev,
 libprotobuf-dev,
 protobuf-compiler,
 protobuf-compiler-grpc,
 capnproto,
 golang-github-osrg-gobgp-dev,
 libhiredis-dev,
 libjson-c-dev,
 liblog4cpp5-dev,
 libicu-dev,
 libmongoc-dev,
 libncurses5-dev,
 libpcap-dev,
 pkg-config
Homepage: https://fastnetmon.com/
Vcs-Browser: https://salsa.debian.org/debian/fastnetmon
Vcs-Git: https://salsa.debian.org/debian/fastnetmon.git

Package: fastnetmon
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
 ${shlibs:Depends}
Description: fast DDoS analyzer with sflow/netflow/mirror support (community edition)
 FastNetMon is a very high performance distributed denial-of-service attack
 (DDoS attack) detector built on top of multiple packet capture engines:
 NetFlow, IPFIX, sFLOW.
 .
 It can detect hosts in your networks sending or receiving large volumes of
 packets/bytes/flows per second. It can call an external script to notify you,
 switch off a server, or blackhole the client.
 .
 To enable sFLOW, simply specify IP of the server running FastNetMon and specify
 (configurable) port 6343. To enable netflow, simply specify IP of the server
 running FastNetMon and specify (configurable) port 2055.
 .
 This package contains the community edition.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifeq (,$(filter-out mips mipsel m68k powerpc powerpcspe sh4,$(DEB_HOST_ARCH)))
EXTRA_ARGS += -DUSE_NEW_ATOMIC_BUILTINS=ON
endif

%:
	dh $@ --buildsystem=cmake --sourcedirectory=src

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_CUSTOM_BOOST_BUILD=FALSE -DDO_NOT_USE_SYSTEM_LIBRARIES_FOR_BUILD=FALSE $(EXTRA_ARGS)

=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg// \
https://github.com/pavel-odintsov/fastnetmon/releases .*/v(\d\S+)\.tar\.gz
